const PccApp = require('../../../picockpit-library/picockpit-base-app')
const ssrv = require('./schemaLib/schema-service')

// translating i18n
// FUTURE
// add OPTIONAL uid gid to  svcSchema
// service hints for needs-reboot
// form deprecate 'name'
// use true false remappers in switch rather than customizing it to rpi-config
// resolve form schema i18n also

class SettingsApp extends PccApp {
    constructor(){
        super("settings")
        //this.debugLog("Init settings app")

        this.schemaSrv = new ssrv("control/conf", this.publish);

        this.client.on('message', (topic, message) => {
            if (message.length > 0){
                message = JSON.parse(message);
            }
            //this.debugLog(`Settings: Received message, topic: ${topic}, message: ${message}`);
            this.onMessage(topic, message);
        })
    }

    onMessage = async (topic, message) => {
        this.schemaSrv.serve(topic, message);
    }
}

settings = new SettingsApp;