const PccApp = require('../../../picockpit-library/picockpit-base-app')
const fetch = require('node-fetch')
const viddev = require("./cam-all");

class StreamvideoApp extends PccApp {
    constructor(){
        super("streamvideo");
        console.log("Streamvideo starting.")
        const mf_res = "control/fetch/res";
        this.client.on('message', (topic, message) => {
            message = JSON.parse(message);
            // console.log("Message: ", message)
            try {
                if (message.path == "/getsources") { // fake endpoint
                    this.publish(mf_res, {nonce:message.nonce, res:{text:JSON.stringify(viddev.getSources())}});
                    return;
                }

                if (message.path == "/v3/config/global/patch") {
                    console.log("Starting streaming server"); // make sure daemon is up
                }

                console.log("FETCHING: ", this.getPath(message.path));
                fetch(this.getPath(message.path), message.payload)
                    .then((res => {
                        res.text().then(((text) => {
                            console.log("publish", mf_res);
                            // for (const [key, value] of res.headers.entries()) {
                            //   console.log("MW" ,key, ':', value);
                            // }
                            console.log("etag: ", res.headers.get("etag"))
                            console.log("location: ", res.headers.get("location"))
                            console.log("status: " , res.status)
                            // console.log("text: ", text)
                            this.publish(mf_res, {nonce:message.nonce, res:{headers:{"etag":res.headers.get("etag"), location:res.headers.get("location")}, status:res.status, text}})
                        }).bind(this)) // send response    
                    }).bind(this))
                    .catch(((error) => {
                        console.log(error); // send error
                        console.log("Error test: ", error)
                        this.publish(mf_res, {error});
                    }).bind(this));
            } catch (e) {
                console.log(e);
            }
        })
    }

    getPath(path) {
        const url = new URL(path, "http://localhost");
        const source = url.searchParams.get("source");
        const session = url.searchParams.get("session");
        const pre ="http://127.0.0.1:9997"; // SUPER weird.  localhost does not work.  Use the IP.

        // Whitelisted fetch endpoints
        const paths = { 
            "/v3/config/global/patch":`${pre}/v3/config/global/patch`,
            "/v3/config/paths/replace":`${pre}/v3/config/paths/replace/${source}`,
            "/source/whep":`http://127.0.0.1:8889/${source}/whep`,
            "/source/whepsess":`http://127.0.0.1:8889/${source}/whep/${session}`
        };

        return paths[url.pathname];
    }
}

streamvideo = new StreamvideoApp;
